MPLS Data Plane Encapsulation for In-situ OAM Data
Internet-Draft draft-gandhi-mpls-ioam-05
Rakesh Gandhi, Ed.
Cisco Systems, Inc.
Canada
rgandhi@cisco.com
Zafar Ali
Cisco Systems, Inc.
zali@cisco.com
Frank Brockners
Cisco Systems, Inc.
Hansaallee 249, 3rd Floor
DUESSELDORF, NORDRHEIN-WESTFALEN 40549
Germany
fbrockne@cisco.com
Bin Wen
Comcast
Bin_Wen@cable.comcast.com
Bruno Decraene
Orange
bruno.decraene@orange.com
Voitek Kozak
Comcast
Voitek_Kozak@comcast.com
06 July 2022
MPLS Working Group
In-situ Operations, Administration, and Maintenance (IOAM) is used for recording and collecting operational and telemetry information while the packet traverses a path between two points in the network. This document defines how IOAM data fields are transported with MPLS data plane encapsulation using MPLS Network Action (MNA) with new Generic Associated Channel (G-ACh) and updates the RFC 5586.
Introduction
In-situ Operations, Administration, and Maintenance (IOAM) is used for recording and collecting operational and telemetry information while the packet traverses a path between two points in the network. The term "in-situ" refers to the fact that the IOAM data fields are added to the data packets rather than being sent within the probe packets specifically dedicated to OAM. The IOAM data fields are defined in [RFC9197]. The IOAM data fields are further updated in [I-D.ietf-ippm-ioam-direct-export] for direct export use-cases.
This document defines how IOAM data fields are transported with MPLS data plane encapsulations using MPLS Network Action (MNA) with new Generic Associated Channel (G-ACh) and updates the [RFC5586].
Conventions
Requirement Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Abbreviations
The MPLS Network Action (MNA) terminology defined in [I-D.andersson-mpls-mna-fwk] are used in this document.
Abbreviations used in this document:
PNI
Post-Stack Network Action Presence Indicator
ECMP
Equal Cost Multi-Path
E2E
Edge-To-Edge
G-ACh
Generic Associated Channel
HBH
Hop-By-Hop
HPI
Hop-By-Hop Post-Stack Network Action Processing Indicator
IOAM
In-situ Operations, Administration, and Maintenance
MPLS
Multiprotocol Label Switching
MNA
MPLS Network Action
OAM
Operations, Administration, and Maintenance
POT
Proof-of-Transit
PW
PseudoWire
MPLS Extensions for IOAM Data Fields
IOAM Generic Associated Channel
The IOAM header is added containing different IOAM-Data-Fields in the MPLS header as shown in Figure 1. The IOAM-Data-Fields MUST follow the definitions corresponding to IOAM-Option-Types (e.g. see Section 4.4 of [RFC9197] and Section 3 of [I-D.ietf-ippm-ioam-direct-export]). More than one trace options can be present in the IOAM-Data-Fields.
G-ACh [RFC5586] provides a mechanism to transport OAM and other control messages over MPLS data plane. The IOAM G-ACh header [RFC5586] with new IOAM G-ACh type MUST be added immediately after the MPLS label stack in the MPLS header as shown in Figure 1, before the IOAM-Data-Fields. The G-ACh label (GAL) [RFC5586] MUST NOT be added in the MPLS label stack.
This document updates the following paragraph in Section 2.1 of [RFC5586]: "The G-ACh MUST NOT be used to transport user traffic" to "The G-ACh MAY be used with user traffic to transport OAM information".
Note that the G-ACh is not really used to transport the user traffic in this document but to transport the IOAM-Data-Fields with the user traffic.
IOAM Generic Associated Channel with IOAM Data Fields

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+<-+
 |0 0 0 1|Version| Length        |          IOAM G-ACh           |  |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  |
 | IOAM-OPT-Type | IOAM HDR Len  | Block Number  | Reserved      |  |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  I
 |                                                               |  O
 |                                                               |  A
 ~                 IOAM Option and Data Space                    ~  M
 |                                                               |  |
 |                                                               |  |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+<-+
 |                                                               |
 |                                                               |
 |                 Optional Payload + Padding                    |
 |                                                               |
 |                                                               |
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

The IOAM-Data-Fields are encapsulated using the following fields in the MPLS header:
IP Version Number 0001b:
The first four octets are IP Version Field part of a G-ACh header, as defined in [RFC5586].
Version:
The Version field is set to 0, as defined in [RFC4385].
Length:
Length of IOAM G-ACh data in 4-octet units. Note that this field is marked as Reserved in [RFC5586] and is updated for the new IOAM G-ACh type by this document.
IOAM G-ACh:
Generic Associated Channel (G-ACh) Type (value TBA1) for IOAM [RFC5586].
Reserved:
Reserved Bits MUST be set to zero upon transmission and ignored upon receipt.
Block Number:
The Block Number can be used to aggregate the IOAM data collected in data plane, e.g. to compute measurement metrics for each block of a data flow. It is also used to correlate the IOAM data on different nodes.
IOAM-OPT-Type:
8-bit field defining the IOAM Option type, as defined in the "IOAM Option-Type Registry" specified in [RFC9197].
IOAM HDR Length:
8-bit unsigned integer. Length of the IOAM Header in 4-octet units.
IOAM Option and Data Space:
IOAM-Data-Fields as specified by the IOAM-OPT-Type field. IOAM-Data-Fields are defined corresponding to the IOAM-Option-Type (e.g. see Section 4.4 of [RFC9197] and Section 3 of [I-D.ietf-ippm-ioam-direct-export].
IOAM Indicators
A Post-Stack Network Action Presence Indicator MUST be added to indicate the presence of the IOAM-Data-Fields in the MPLS header. If both edge and intermediate nodes need to process IOAM data then both Presence Indicator and HBH Network Action Processing Indicator MUST be added. The HBH Processing Indicator allows to optimize the IOAM processing on intermediate nodes and avoids the need to parse all IOAM-Data-Fields.
A flag called PNI (Post-Stack Network Action Presence Indicator) in the TTL field defined in [I-D.jags-mpls-mna-hdr] is used in this document to indicate the presence of IOAM Post-Stack Network Action and Ancillary Data. A flag called HPI (Hop-By-Hop Post-Stack Network Action Processing Indicator) in the TTL field defined in [I-D.jags-mpls-mna-hdr] is used to indicate that HBH processing in Post-Stack Network Action and Ancillary Data is required.
The MNA Label used in this document is a Special Purpose Label (value TBA2) assigned by IANA, and is defined as Network Action Sub-Stack Indicator (NASI) in [I-D.jags-mpls-mna-hdr].
Edge-to-Edge IOAM
Post-Stack Network Action Presence Indicator
The Post-Stack Network Action Presence Indicator is used to indicate the presence of the IOAM-Data-Fields in the MPLS header as shown in Figure 2.
Example MPLS Encapsulation for IOAM

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |  Label                                | TC  |S|  TTL          |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 .                                                               .
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |  MNA Label (SPL value TBA2)           | TC  |S|  TTL          |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                       | TC  |1|  PNI=1        |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                Packet as shown in Figure 1                    |
 .                                                               .
 +---------------------------------------------------------------+

The E2E IOAM-Data-Fields carry the Option-Type(s) that require processing on the encapsulating and decapsulating nodes only. The IOAM Option-Type carried can be IOAM Edge-to-Edge Option-Type [RFC9197]. The E2E IOAM-Data-Fields SHOULD NOT carry any IOAM Option-Type that require IOAM processing on the intermediate nodes as it will not be processed by them.
Procedure for Edge-to-Edge IOAM
The E2E IOM procedure is summarized as following:
- The encapsulating node inserts the MNA Label (SPL value TBA2) with the Post-Stack Network Action Presence Indicator (TTL Flag PNI) below the label whose FEC is the end (decapsulating) node and one or more IOAM-Data-Fields in the MPLS header.
- The intermediate nodes do not process IOAM-Data-Fields.
- The penultimate node MUST NOT remove the MPLS header. This is ensured by the encapsulating node by adding required MPLS header.
- The decapsulating node MAY punt a copy of the packet with the receive timestamp to the slow path for IOAM-Data-Fields processing when the node recognizes the PNI. The receive timestamp is required by the various E2E OAM use-cases, including streaming telemetry. Note that the packet is not necessarily punted to the control-plane.
- The decapsulating node processes the IOAM-Data-Fields using the procedures defined in [RFC9197]. An example of IOAM processing is to export the IOAM-Data-Fields, send IOAM-Data-Fields via streaming telemetry, etc.
- The decapsulating node MUST remove the IOAM-Data-Fields from the received packet. The decapsulated packet is forwarded downstream or terminated locally similar to the regular IOAM-Data-Fields.
Hop-By-Hop IOAM
Hop-By-Hop Post-Stack Network Action Processing Indicator
The Post-Stack Network Action Presence Indicator (TTL Flag PNI) along with Hop-By-Hop Processing Indicator (TTL Flag HPI) are used to indicate the presence of the HBH IOAM-Data-Fields in the MPLS header as shown in Figure 3.
Example MPLS Encapsulation for HBH IOAM

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |  Label                                | TC  |S|  TTL          |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 .                                                               .
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |  MNA Label (SPL value TBA2)           | TC  |S|  TTL          |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                       | TC  |1| PNI=1, HPI    |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                Packet as shown in Figure 1                    |
 .                                                               .
 +---------------------------------------------------------------+

The HBH IOAM-Data-Fields carry the Option-Type(s) that require processing at the intermediate and/or encapsulating and decapsulating nodes. The IOAM Option-Type carried can be IOAM Pre-allocated Trace Option-Type, IOAM Incremental Trace Option-Type and IOAM Proof of Transit (POT) Option-Type, as well as Edge-to-Edge Option-Type [RFC9197].
Procedure for Hop-By-Hop IOAM
The HBH IOAM procedure is summarized as following:
- The encapsulating node inserts the MNA Label with the Post-Stack Network Action Presence Indicator (TTL Flag PNI) and HBH Processing Indicator (TTL Flag HPI) below the label whose FEC is the end (decapsulating) node and one or more IOAM-Data-Fields in the MPLS header.
- The intermediate node enabled with HBH IOAM function processes the data packet including the IOAM-Data-Fields as defined in [RFC9197] when the node recognizes the HBH Processing Indicator in the MPLS header.
- The intermediate node MAY punt a copy of the packet with the receive timestamp to the slow path for IOAM-Data-Fields processing when the node recognizes the HBH Processing Indicator. The receive timestamp is required by the various HBH OAM use-cases, including streaming telemetry. Note that the packet is not necessarily punted to the control-plane.
- The intermediate node forwards a copy of the processed data packet downstream.
- The penultimate node MUST NOT remove the MPLS header. This is ensured by the encapsulating node by adding required MPLS header.
- The processing on the decapsulating node is same as E2E case.
Considerations for IOAM
Considerations for ECMP
The encapsulating node needs to make sure the IOAM-Data-Fields do not start with a well-known IP Version Number (e.g. 0x4 for IPv4 and 0x6 for IPv6) as that can alter the hashing function for ECMP that uses the IP header. This is achieved by using the IOAM G-ACh with IP Version Number 0001b after the MPLS label stack [RFC5586].
Node Capability
The decapsulating node that has to remove the IOAM-Data-Fields and perform the IOAM function may not be capable of supporting it. The encapsulating node needs to know if the decapsulating node can support the IOAM function. The signaling extension for this capability exchange is outside the scope of this document.
The intermediate node that is not capable of supporting the IOAM functions defined in this document, can simply skip the IOAM processing.
The intermediate node that does not understand the MNA Label received at the top of the label stack will drop the packet.
Nested MPLS Encapsulation
When a packet is received with IOAM, the nested MPLS encapsulating node that supports a different IOAM, the node MUST add a new MNA Label with the supported IOAM as part of the new MPLS encapsulation.
Security Considerations
The security considerations of IOAM in general are discussed in [RFC9197] and apply to the procedure defined in this document.
IOAM is considered a "per domain" feature, where one or several operators decide on configuring IOAM according to their needs. IOAM is intended for deployment in limited domains [RFC8799]. As such, it assumes that a node involved in IOAM operation has previously verified the integrity of the path. Still, operators need to properly secure the IOAM domain to avoid malicious configuration and use, which could include injecting malicious IOAM packets into the domain.
Routers that support G-ACh are subject to the same security considerations as defined in [RFC4385] and [RFC5586].
IANA Considerations
IANA maintains G-ACh Type Registry (see https://www.iana.org/assignments/g-ach-parameters/g-ach-parameters.xhtml). IANA is requested to allocate a value for IOAM G-ACh Type from "MPLS Generalized Associated Channel (G-ACh) Types (including Pseudowire Associated Channel Types)" registry.
IOAM G-ACh Type
Value | Description | Reference
TBA1 | IOAM G-ACh Type | This document
Appendix
MPLS Encapsulation with Control Word and Another G-ACh for IOAM Data Fields
The IOAM-Data-Fields, including IOAM G-ACh header are added in the MPLS encapsulation immediately after the MPLS header. Any Control Word [RFC4385] or another G-ACh [RFC5586] MUST be added after the IOAM-Data-Fields in the packet as shown in the Figure 4 and Figure 5, respectively. This allows the intermediate nodes to easily access the HBH IOAM-Data-Fields located immediately after the MPLS header. The decapsulating node can remove the MPLS encapsulation including the IOAM-Data-Fields and then process the Control Word or another G-ACh following it. The subsequent G-ACh and Control Word are located through the use of the "Length" field in the IOAM G-ACh.
Example MPLS Encapsulation with Generic PW Control Word with HBH IOAM

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |  MNA Label (SPL value TBA2)           | TC  |S|  TTL          |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                       | TC  |1| PNI=1, HPI    |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |0 0 0 1|Version| Length        | IOAM G-ACh                    |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+<-+
 | IOAM-OPT-Type | IOAM HDR Len  | Block Number  | Reserved      |  |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  I
 |                                                               |  O
 |                                                               |  A
 ~                 IOAM Option and Data Space                    ~  M
 |                                                               |  |
 |                                                               |  |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+<-+
 |0 0 0 0| Specified by PW Encapsulation [RFC4385]               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                                               |
 |                                                               |
 ~                 Payload + Padding                             ~
 |                                                               |
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Example MPLS Encapsulation with Another G-ACh with HBH IOAM

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |  MNA Label (SPL value TBA2)           | TC  |S|  TTL          |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                       | TC  |1| PNI=1, HPI    |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |0 0 0 1|Version| Length        | IOAM G-ACh                    |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+<-+
 | IOAM-OPT-Type | IOAM HDR Len  | Block Number  | Reserved      |  |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+  I
 |                                                               |  O
 |                                                               |  A
 ~                 IOAM Option and Data Space                    ~  M
 |                                                               |  |
 |                                                               |  |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+<-+
 |0 0 0 1|Version| Reserved      | Channel Type                  |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                                                               |
 |                                                               |
 ~                 Payload + Padding                             ~
 |                                                               |
 |                                                               |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

References
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC5586]

MPLS Generic Associated Channel
M. Bocci, Ed.
M. Vigoureux, Ed.
S. Bryant, Ed.
June 2009
RFC 5586
DOI 10.17487/RFC5586
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[I-D.ietf-ippm-ioam-direct-export]

In-situ OAM Direct Exporting
Haoyu Song
Futurewei
Barak Gafni
Nvidia
Frank Brockners
Cisco
Shwetha Bhandari
Thoughtspot
Tal Mizrahi
Huawei
15 June 2022
Internet-Draft draft-ietf-ippm-ioam-direct-export-09
[RFC9197]

Data Fields for In Situ Operations, Administration, and Maintenance
Frank Brockners
Cisco Systems, Inc.
Shwetha Bhandari
Thoughtspot
Tal Mizrahi
Huawei
May 2022
RFC 9197
Informative References
[I-D.andersson-mpls-mna-fwk]

MPLS Network Actions Framework
Loa Andersson
Stewart Bryant
Matthew Bocci
27 June 2022
Internet-Draft draft-andersson-mpls-mna-fwk-04.txt
[I-D.jags-mpls-mna-hdr]

MPLS Network Action Header Encodings
Jaganbabu Rajamanickam
Cisco Systems, Inc.
Rakesh Gandhi
Cisco Systems, Inc.
Jisu Bhattacharya
Cisco Systems, Inc.
Bruno Decraene
Orange
Royi Zigler
Broadcom
Weiqiang Cheng
China Mobile
Luay Jalil
Verizon
Haoyu Song
Futurewei Technologies
06 July 2022
Internet-Draft draft-jags-mpls-mna-hdr-00
[RFC4385]

Pseudowire Emulation Edge-to-Edge (PWE3) Control Word for Use over an MPLS PSN
S. Bryant
G. Swallow
L. Martini
D. McPherson
February 2006
RFC 4385
DOI 10.17487/RFC4385
[RFC8799]

Limited Domains and Internet Protocols
B. Carpenter
B. Liu
July 2020
RFC 8799
DOI 10.17487/RFC8799
Acknowledgements
The authors would like to thank Patrick Khordoc, Sagar Soni, Shwetha Bhandari, Clarence Filsfils, and Vengada Prasad Govindan for the discussions on IOAM. The authors would also like to thank Tarek Saad, Loa Andersson, Greg Mirsky, Stewart Bryant, Xiao Min, and Cheng Li for providing many useful comments. The authors would also like to thank Mach Chen, Andrew Malis, Matthew Bocci, and Nick Delregno for the MPLS-RT reviews.